<cfset attributes = {} />
<cfset structAppend(attributes, form, false) />
<cfset structAppend(attributes, url, false) />

<cffunction name="new">
	<cfargument name="type" />
	<cfreturn createObject("component", type) />
</cffunction>
<cffunction name="parseFusebox">
	<cfargument name="fn" />
	<cfset var circuits = {} />
	<cfset var xml = xmlParse(fileRead(fn)) />
	<cfset var i = "" />
	<cfset var c = "" />
	<cfset var cfn = "" />
	<cfset circuits.__globalfuseactions__ = {
		preprocess = {
			type = "preprocess",
			verbs = []
		},
		postprocess = {
			type = "postprocess",
			verbs = []
		}
	} />
	<cfloop array="#xmlSearch(xml, '//globalfuseactions/preprocess/*')#" index="i">
		<cfset s = {
			type = "do",
			action = i.xmlAttributes.action
		} />
		<cfset arrayAppend(circuits.__globalfuseactions__.preprocess.verbs, s) />
	</cfloop>
	<cfloop array="#xmlSearch(xml, '//globalfuseactions/postprocess/*')#" index="i">
		<cfset s = {
			type = "do",
			action = i.xmlAttributes.action
		} />
		<cfset arrayAppend(circuits.__globalfuseactions__.postprocess.verbs, s) />
	</cfloop>
	<cfloop from="1" to="#arrayLen(xml.xmlRoot.circuits.circuit)#" index="i">
		<cfset c = xml.xmlRoot.circuits.circuit[i] />
		<cfset cfn = getDirectoryFromPath(fn) & c.xmlAttributes.path & "/" & "circuit.xml" />
		<cfif NOT fileExists(cfn)>
			<cfset cfn &= ".cfm" />
		</cfif>
		<cfif NOT fileExists(cfn)>
			<cfthrow type="IllegalStateException"
				message="Could not find circuit.xml for circuit '#c.xmlAttributes.alias#' in '#getDirectoryFromPath(cfn)#'" />
		</cfif>
		<cfset circuits[c.xmlAttributes.alias] = parseCircuit(cfn, c.xmlAttributes.alias) />
	</cfloop>
	<cfreturn circuits />
</cffunction>
<cffunction name="parseCircuit">
	<cfargument name="fn" />
	<cfargument name="alias" />
	<cfset var xml = xmlParse(fileRead(fn)) />
	<cfset var fuseactions = {} />
	<cfset var i = "" />
	<cfset var fa = "" />
	<cfset fa = xmlSearch(xml, "//prefuseaction") />
	<cfif arrayLen(fa) GT 0>
		<cfset fuseactions.__prefuseaction__ = {
			type = "prefuseaction",
			circuit = alias,
			verbs = parseVerbs(fa[1].xmlChildren)
		} />
	</cfif>
	<cfset fa = xmlSearch(xml, "//postfuseaction") />
	<cfif arrayLen(fa) GT 0>
		<cfset fuseactions.__postfuseaction__ = {
			type = "postfuseaction",
			circuit = alias,
			verbs = parseVerbs(fa[1].xmlChildren)
		} />
	</cfif>
	<cfloop from="1" to="#arrayLen(xml.xmlRoot.fuseaction)#" index="i">
		<cfset fa = xml.xmlRoot.fuseaction[i] />
		<cfset fuseactions[fa.xmlAttributes.name] = parseFuseaction(fa) />
	</cfloop>
	<cfreturn fuseactions />
</cffunction>
<cffunction name="parseFuseaction">
	<cfargument name="node" />
	<cfset var s = {
		name = node.xmlAttributes.name,
		verbs = parseVerbs(node.xmlChildren)
	} />
	<cfreturn s />
</cffunction>
<cffunction name="parseVerbs">
	<cfargument name="nodes" />
	<cfset var i = "" />
	<cfset var a = [] />
	<cfloop from="1" to="#arrayLen(nodes)#" index="i">
		<cfset arrayAppend(a, parseVerb(nodes[i])) />
	</cfloop>
	<cfreturn a />
</cffunction>
<cffunction name="parseVerb">
	<cfargument name="node" />
	<cfset var s = {
		type = node.xmlName,
		attributes = node.xmlAttributes
	} />
	<cfset var i = "" />
	<cfif s.type EQ "if">
		<cfloop from="1" to="#arrayLen(node.xmlChildren)#" index="i">
			<cfif node.xmlChildren[i].xmlName EQ "true">
				<cfset s.trueVerbs = parseVerbs(node.xmlChildren[i].xmlChildren) />
			<cfelseif node.xmlChildren[i].xmlName EQ "false">
				<cfset s.falseVerbs = parseVerbs(node.xmlChildren[i].xmlChildren) />
			</cfif>
		</cfloop>
		<cfif NOT structKeyExists(s, "trueVerbs") AND NOT structKeyExists(s, "falseVerbs")>
			<!--- support for when the <true> tag was optional --->
			<cfset s.trueVerbs = parseVerbs(node.xmlChildren) />
		</cfif>
		<cfif NOT structKeyExists(s, "trueVerbs")>
			<cfset s.trueVerbs = [] />
		</cfif>
		<cfif NOT structKeyExists(s, "falseVerbs")>
			<cfset s.falseVerbs = [] />
		</cfif>
	<cfelseif listFindNoCase("loop,view.savecontent,view.div", s.type) GT 0>
		<cfset s.verbs = parseVerbs(node.xmlChildren) />
	<cfelseif s.type EQ "do">
		<cfset s.action = node.xmlAttributes.action />
	</cfif>
	<cfreturn s />
</cffunction>
<cffunction name="inlineDos">
	<cfargument name="verbs" />
	<cfargument name="alias" />
	<cfset var v = "" />
	<cfset var c = "" />
	<cfset var fa = "" />
	<cfset var s = "" />
	<cfloop array="#verbs#" index="v">
		<cfif v.type EQ "do">
			<cfif v.action CONTAINS ".">
				<cfset c = listFirst(v.action, ".") />
				<cfset fa = listRest(v.action, ".") />
			<cfelse>
				<cfset c = alias />
				<cfset fa = v.action />
			</cfif>
			<cfset v.circuit = c />
			<cfif structKeyExists(circuits, c)>
				<cfif structKeyExists(circuits[c], fa)>
					<cfset v.verbs = inlineDos(circuits[c][fa].verbs, c) />
					<cfif attributes.pfa AND structKeyExists(circuits[c], "__prefuseaction__")>
						<cfset arrayPrepend(v.verbs, circuits[c].__prefuseaction__) />
					</cfif>
					<cfif attributes.pfa AND structKeyExists(circuits[c], "__postfuseaction__")>
						<cfset arrayAppend(v.verbs, circuits[c].__postfuseaction__) />
					</cfif>
				<cfelse>
					<cfset v.verbs = [{
						type = "unknownfuseaction"
					}] />
				</cfif>
			<cfelse>
				<cfset v.verbs = [{
					type = "unknowncircuit"
				}] />
			</cfif>
		<cfelseif listFindNoCase("loop,view.savecontent,view.div", v.type) GT 0>
			<cfset v.verbs = inlineDos(v.verbs, alias) />
		<cfelseif v.type EQ "if">
			<cfset v.trueVerbs = inlineDos(v.trueVerbs, alias) />
			<cfset v.falseVerbs = inlineDos(v.falseVerbs, alias) />
		</cfif>
	</cfloop>
	<cfreturn verbs />
</cffunction>
	
<cfparam name="attributes.fn" default="#getDirectoryFromPath(getCurrentTemplatePath())#circuit.xml" />
<cfparam name="attributes.fa" default="" />

<cfoutput>
<style type="text/css">
</style>
<form method="get">
Filename (circuit.xml OR fusebox.xml):<br />
<input name="fn" value="#htmlEditFormat(attributes.fn)#" size="80" />
<input type="submit" value="Go!" />
</form>
<cfif len(attributes.fn) GT 0 AND NOT fileExists(attributes.fn)>
	<p>I couldn't find your file...
	</p>
<cfelse>
	<cfif listLast(attributes.fn, "/\").startsWith("circuit.xml")>
		<cfset fullFusebox = false />
		<cfset circuits["c"] = parseCircuit(attributes.fn, "c") />
	<cfelseif listLast(attributes.fn, "/\").startsWith("fusebox.xml")>
		<cfset fullFusebox = true />
		<cfset circuits = parseFusebox(attributes.fn) />
	<cfelse>
		<cfthrow type="IllegalArgumentException"
			message="The filename you specified is not a valid Fusebox fusebox.xml or circuit.xml file." />
	</cfif>
	
	<cfset attributes.c = listFirst(attributes.fa, '.') />
	<cfset attributes.fa = listRest(attributes.fa, '.') />
	<cfparam name="attributes.gfa" default="false" />
	<cfparam name="attributes.pfa" default="false" />

	<form method="get">
		<input type="hidden" name="fn" value="#htmlEditFormat(attributes.fn)#" />
		Fuseaction:
		<select name="fa" onchange="this.form.submit();">
			<option></option>
			<cfloop list="#listSort(structKeyList(circuits), 'textnocase')#" index="c">
				<cfif c NEQ "__globalfuseactions__">
					<cfif fullFusebox>
						<optgroup label="#c#">
					</cfif>
						<cfloop list="#listSort(structKeyList(circuits[c]), 'textnocase')#" index="fa">
							<cfif fa NEQ "__prefuseaction__" AND fa NEQ "__postfuseaction__">
								<option value="#c#.#fa#"<cfif attributes.c EQ c AND attributes.fa EQ fa> selected="selected"</cfif>>#fa#</option>
							</cfif>
						</cfloop>
					<cfif fullFusebox>
						</optgroup>
					</cfif>
				</cfif>
			</cfloop>
		</select>
		<cfif fullFusebox>
			<label><input name="gfa" type="checkbox" value="1" <cfif attributes.gfa> checked="checked"</cfif> /> Global Fuseactions</label>
			<label><input name="pfa" type="checkbox" value="1" <cfif attributes.pfa> checked="checked"</cfif> /> Pre/Post Fuseactions</label>
		</cfif>
		<input type="submit" value="Go!" />
	</form>
	
	<cfif structKeyExists(circuits, attributes.c) AND structKeyExists(circuits[attributes.c], attributes.fa)>
		<cfset fa = circuits[attributes.c][attributes.fa] />
		<cfset chart = new("shapelist").init() />
		<cfif attributes.gfa>
			<cfset circuits.__globalfuseactions__.preprocess.verbs = inlineDos(circuits.__globalfuseactions__.preprocess.verbs) />
			<cfset chart.addVerb(circuits.__globalfuseactions__.preprocess) />
		</cfif>
		<cfset s = [{
			type = "do",
			action = attributes.c & "." & attributes.fa,
			verbs = inlineDos(fa.verbs, attributes.c)
		}] />
		<cfset chart.addVerbs(inlineDos(s)) />
		<cfif attributes.gfa>
			<cfset circuits.__globalfuseactions__.postprocess.verbs = inlineDos(circuits.__globalfuseactions__.postprocess.verbs) />
			<cfset chart.addVerb(circuits.__globalfuseactions__.postprocess) />
		</cfif>
		<cfset m = chart.measure() />
		<cfset img = imageNew("", m.width + 10, m.height + 10, "rgb", "ffffff") />
		<cfset imageSetDrawingColor(img, "000000") />
		<cfset imageTranslateDrawingAxis(img, m.width / 2 + 5, 5) />
<!---
<cfset chart.msg("") />
<cfset chart.msg("") />
<cfset chart.msg("") />
<cfset chart.msg("") />
--->
		<cfset chart.draw(img) />
		<cfset fn = getDirectoryFromPath(getCurrentTemplatePath()) & "#createUuid()#.png" />
		<cfset imageWrite(img, fn) />
		<img id="chart" src="data:image/png;base64,#toBase64(fileReadBinary(fn))#" />
		<cfset fileDelete(fn) />
	</cfif>
</cfif>
</cfoutput>
