<cfcomponent extends="shape" output="false">
	
	<cfset TOP_MARGIN = 10 />
	<cfset LEFT_MARGIN = 10 />
	<cfset HEADER_HEIGHT = 30 />
	<cfset RIGHT_MARGIN = 10 />
	<cfset BOTTOM_MARGIN = 15 />
	<cfset MIN_HEIGHT_FOR_FOOTER = 200 />
	
	<cffunction name="init" access="public" output="false" returntype="shape">
		<cfargument name="verb" type="struct" required="false" />
		<cfset super.init(verb) />
		<cfset variables.my.list = createObject("component", "shapelist").init(verb.verbs) />
		<cfreturn this />
	</cffunction>
	


	<cffunction name="draw" access="public" output="false" returntype="void">
		<cfargument name="img" type="any" required="true" />
		<cfset var m = measure() />
		<cfset var txt = getLabel() />
		<cfset var shape = "" />
		<cfset var drawFooter = my.list.measure().height GTE MIN_HEIGHT_FOR_FOOTER />
<!---
<cfset msg("do (#m.width# x #m.height#)") />
--->
		<cfif isFlowTerminated()>
			<cfset my.list.setFlowTerminated(true) />
		</cfif>
		<cfif my.verb.type EQ "prefuseaction" OR my.verb.type EQ "preprocess">
			<cfset imageSetDrawingColor(img, "eeffee") />
		<cfelseif my.verb.type EQ "postfuseaction" OR my.verb.type EQ "postprocess">
			<cfset imageSetDrawingColor(img, "eeeeff") />
		<cfelse>
			<cfset imageSetDrawingColor(img, "eeeeee") />
		</cfif>
		<cfset imageDrawRect(img, m.width / -2, 0, m.width, HEADER_HEIGHT, true) />
		<cfif drawFooter>
			<cfset imageDrawRect(img, m.width / -2, m.height - HEADER_HEIGHT, m.width, HEADER_HEIGHT, true) />
		</cfif>
		<cfif isFlowTerminated()>
			<cfset imageSetDrawingColor(img, "dddddd") />
		<cfelse>
			<cfset imageSetDrawingColor(img, "bbbbbb") />
		</cfif>
		<cfset imageDrawLine(img, m.width / -2, HEADER_HEIGHT, m.width / 2, HEADER_HEIGHT) />
		<cfif drawFooter>
			<cfset imageDrawLine(img, m.width / -2, m.height - HEADER_HEIGHT, m.width / 2, m.height - HEADER_HEIGHT) />
		</cfif>
		<cfset imageDrawRect(img, m.width / -2, 0, m.width, m.height) />
		<cfset resetColors(img) />
		<cfset imageDrawText(img, txt, getTextWidth(txt) / -2, (HEADER_HEIGHT + getTextHeight()) / 2) />
		<cfif drawFooter>
			<cfset imageDrawText(img, txt, getTextWidth(txt) / -2, m.height - (HEADER_HEIGHT - getTextHeight()) / 2) />
		</cfif>
		<cfset imageTranslateDrawingAxis(img, 0, HEADER_HEIGHT + TOP_MARGIN) />
		<cfset my.list.draw(img) />
		<cfset imageTranslateDrawingAxis(img, 0, -1 * (HEADER_HEIGHT + TOP_MARGIN)) />
	</cffunction>



	<cffunction name="measureInternal" access="private" output="false" returntype="struct">
		<cfset var m = my.list.measure() />
		<cfset var s = {
			width = LEFT_MARGIN + max(max(BOX_WIDTH, getLabelWidth()), m.width) + RIGHT_MARGIN,
			height = HEADER_HEIGHT + TOP_MARGIN + m.height + BOTTOM_MARGIN + iif(m.height LT MIN_HEIGHT_FOR_FOOTER, 0, de(HEADER_HEIGHT))
		} />
		<cfreturn s />
	</cffunction>

</cfcomponent>