<cfcomponent extends="shape" output="false">
	
	<cfset this.RIGHT_MARGIN = 30 />
	<cfset this.CONDITION_BOTTOM_MARGIN = 30 />
	<cfset this.BOTTOM_MARGIN_INNER = 10 />
	<cfset this.BOTTOM_MARGIN_OUTER = 10 />
	<cfset this.LEFT_MARGIN = 30 />
	
	<cfset TOP_MARGIN = 20 />
	
	<cffunction name="init" access="public" output="false" returntype="shape">
		<cfargument name="verb" type="struct" required="false" />
		<cfset super.init(verb) />
		<cfset variables.my.list = createObject("component", "shapelist").init(verb.verbs) />
		<cfset variables.my.condition = createObject("component", "loopconditional").init(this) />
		<cfreturn this />
	</cffunction>
	


	<cffunction name="getLabel" access="public" output="false" returntype="string">
		<cfreturn my.verb.type />
	</cffunction>



	<cffunction name="draw" access="public" output="false" returntype="void">
		<cfargument name="img" type="any" required="true" />
		<cfset var m = measure() />
		<cfset var txt = getLabel() />
		<cfset var shape = "" />
<!---
<cfset msg("loop (#m.width# x #m.height#)") />
<cfset imageSetDrawingColor(img, "ff9999") />
<cfset imageDrawRect(img, m.width / -2, 0, m.width, m.height) />
--->
		<cfset resetColors(img) />
		<cfif isFlowTerminated()>
			<cfset my.list.setFlowTerminated(true) />
		</cfif>
		
		<cfset my.condition.draw(img) />
		<cfset imageTranslateDrawingAxis(img, 0, my.condition.measure().height + this.CONDITION_BOTTOM_MARGIN) />
		<cfset my.list.draw(img) />
		<cfset imageTranslateDrawingAxis(img, 0, -1 * (my.condition.measure().height + this.CONDITION_BOTTOM_MARGIN)) />
	</cffunction>



	<cffunction name="measureInternal" access="private" output="false" returntype="struct">
		<cfset var m = my.list.measure() />
		<cfset var cm = my.condition.measure() />
		<cfset var s = {
			width = this.LEFT_MARGIN + max(m.width, cm.width) + this.RIGHT_MARGIN,
			height = cm.height + this.CONDITION_BOTTOM_MARGIN + m.height + this.BOTTOM_MARGIN_INNER + this.BOTTOM_MARGIN_OUTER
		} />
		<cfreturn s />
	</cffunction>

</cfcomponent>