<cfcomponent extends="shape" output="false">

	<cfset BOX_WIDTH = 120 />
	<cfset BOTTOM_MARGIN_INNER = 10 />
	<cfset BOTTOM_MARGIN_OUTER = 20 />

	<cffunction name="init" access="public" output="false" returntype="loopconditional">
		<cfargument name="loop" type="loop" required="true" />
		<cfset variables.my.loop = loop />
		<cfset my.flowTerminated = false />
		<cfreturn this />
	</cffunction>
	
	

	<cffunction name="draw" access="public" output="false" returntype="void">
		<cfargument name="img" type="any" required="true" />
		<cfset var m = measure() />
		<cfset var lm = my.loop.measure() />
		<cfset var txt = "loop" />
<!---
<cfset msg("loop condition (#m.width# x #m.height#)") />
--->
		<cfset resetColors(img) />
		<!--- box --->
		<cfset imageDrawLine(img, 0, 0, BOX_WIDTH / 2, BOX_HEIGHT / 2) />
		<cfset imageDrawLine(img, BOX_WIDTH / 2, BOX_HEIGHT / 2, 0, BOX_HEIGHT) />
		<cfset imageDrawLine(img, 0, BOX_HEIGHT, BOX_WIDTH / -2, BOX_HEIGHT / 2) />
		<cfset imageDrawLine(img, BOX_WIDTH / -2, BOX_HEIGHT / 2, 0, 0) />
		<cfset imageDrawText(img, txt, getTextWidth(txt) / -2, (BOX_HEIGHT + getTextHeight()) / 2) />
		<!--- continue arrow --->
		<cfset imageDrawLine(img, 0, BOX_HEIGHT, 0, BOX_HEIGHT + my.loop.CONDITION_BOTTOM_MARGIN) />
		<cfset imageDrawLine(img, 0, BOX_HEIGHT + my.loop.CONDITION_BOTTOM_MARGIN, -10, BOX_HEIGHT + my.loop.CONDITION_BOTTOM_MARGIN - 10) />
		<cfset imageDrawLine(img, 0, BOX_HEIGHT + my.loop.CONDITION_BOTTOM_MARGIN, 10, BOX_HEIGHT + my.loop.CONDITION_BOTTOM_MARGIN - 10) />
		<cfset imageDrawText(img, "continue", 5, BOX_HEIGHT + getTextHeight()) />
		<!--- break arrow --->
		<cfset imageDrawLine(img, BOX_WIDTH / 2, BOX_HEIGHT / 2, (lm.width - my.loop.RIGHT_MARGIN) / 2, BOX_HEIGHT / 2) />
		<cfset imageDrawLine(img, (lm.width - my.loop.RIGHT_MARGIN) / 2, BOX_HEIGHT / 2, (lm.width - my.loop.RIGHT_MARGIN) / 2, lm.height) />
		<cfset imageDrawLine(img, (lm.width - my.loop.RIGHT_MARGIN) / 2, lm.height, 0, lm.height) />
		<!--- this deliberately overhangs the bottom edge by 10 points --->
		<cfset imageDrawLine(img, 0, lm.height, 0, lm.height + 10) />
		<cfset imageDrawText(img, "break", BOX_WIDTH / 2 + 5, BOX_HEIGHT / 2 - 5) />
		<!--- loop arrow --->
		<cfset imageDrawLine(img, 0, lm.height - my.loop.BOTTOM_MARGIN_INNER - my.loop.BOTTOM_MARGIN_OUTER, 0, lm.height - my.loop.BOTTOM_MARGIN_OUTER) />m.height - my.loop.BOTTOM_MARGIN_OUTER) />
		<cfset imageDrawLine(img, 0, lm.height - my.loop.BOTTOM_MARGIN_OUTER, (lm.width - my.loop.LEFT_MARGIN) / -2, lm.height - my.loop.BOTTOM_MARGIN_OUTER) />
		<cfset imageDrawLine(img, (lm.width - my.loop.LEFT_MARGIN) / -2, lm.height - my.loop.BOTTOM_MARGIN_OUTER, (lm.width - my.loop.LEFT_MARGIN) / -2, BOX_HEIGHT / 2) />
		<cfset imageDrawLine(img, (lm.width - my.loop.LEFT_MARGIN) / -2, BOX_HEIGHT / 2, BOX_WIDTH / -2, BOX_HEIGHT / 2) />
		<cfset imageDrawLine(img, BOX_WIDTH / -2, BOX_HEIGHT / 2, BOX_WIDTH / -2 - 10, BOX_HEIGHT / 2 - 10) />
		<cfset imageDrawLine(img, BOX_WIDTH / -2, BOX_HEIGHT / 2, BOX_WIDTH / -2 - 10, BOX_HEIGHT / 2 + 10) />
	</cffunction>



	<cffunction name="measureInternal" access="private" output="false" returntype="struct">
		<cfset var s = {
			width = BOX_WIDTH + getTextWidth("break") + 5,
			height = BOX_HEIGHT
		} />
		<cfreturn s />
	</cffunction>

</cfcomponent>